if (!defined &_SYS_FS_UFS_INODE_H) {
    eval 'sub _SYS_FS_UFS_INODE_H {1;}';
    require 'sys/isa_defs.ph';
    require 'sys/fbuf.ph';
    require 'sys/fcntl.ph';
    require 'sys/uio.ph';
    require 'sys/t_lock.ph';
    require 'sys/thread.ph';
    require 'sys/cred.ph';
    require 'sys/time.ph';
    require 'sys/fs/ufs_fs.ph';
    require 'sys/fs/ufs_lockfs.ph';
    require 'sys/fs/ufs_trans.ph';
    require 'sys/kstat.ph';
    require 'sys/fs/ufs_acl.ph';
    require 'sys/fs/ufs_panic.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub UID_LONG {( &o_uid_t)65535;}';
    eval 'sub GID_LONG {( &o_uid_t)65535;}';
    eval 'sub NDADDR {12;}';
    eval 'sub NIADDR {3;}';
    eval 'sub FSL_SIZE {( &NDADDR+ &NIADDR-1) * $sizeof{ &daddr_t};}';
    eval 'sub i_fs { &i_ufsvfs-> &vfs_bufp-> &b_un. &b_fs;}';
    eval 'sub i_vfs { &i_vnode. &v_vfsp;}';
    if (defined &_KERNEL) {
    }
    else {
    }
    eval 'sub i_mode { &i_ic. &ic_smode;}';
    eval 'sub i_nlink { &i_ic. &ic_nlink;}';
    eval 'sub i_uid { &i_ic. &ic_uid;}';
    eval 'sub i_gid { &i_ic. &ic_gid;}';
    eval 'sub i_smode { &i_ic. &ic_smode;}';
    eval 'sub i_suid { &i_ic. &ic_suid;}';
    eval 'sub i_sgid { &i_ic. &ic_sgid;}';
    if (defined &_LITTLE_ENDIAN) {
	eval 'sub i_size { &i_ic. &ic_size. &val[0];}';
	eval 'sub i_size_o { &i_ic. &ic_size. &val[1];}';
    }
    else {
	eval 'sub i_size { &i_ic. &ic_size. &val[1];}';
	eval 'sub i_size_o { &i_ic. &ic_size. &val[0];}';
    }
    eval 'sub i_db { &i_ic. &ic_db;}';
    eval 'sub i_ib { &i_ic. &ic_ib;}';
    eval 'sub i_atime { &i_ic. &ic_atime;}';
    eval 'sub i_mtime { &i_ic. &ic_mtime;}';
    eval 'sub i_ctime { &i_ic. &ic_ctime;}';
    eval 'sub i_shadow { &i_ic. &ic_shadow;}';
    eval 'sub i_blocks { &i_ic. &ic_blocks;}';
    if (defined &_LITTLE_ENDIAN) {
	eval 'sub i_ordev { &i_ic. &ic_db[1];}';
    }
    else {
	eval 'sub i_ordev { &i_ic. &ic_db[0];}';
    }
    eval 'sub i_gen { &i_ic. &ic_gen;}';
    eval 'sub i_forw { &i_chain[0];}';
    eval 'sub i_back { &i_chain[1];}';
    if (defined( &DEBUG)) {
	eval 'sub i_cksum { &i_ic. &ic_oeftflag;}';
	eval 'sub di_cksum { &di_ic. &ic_oeftflag;}';
    }
    eval 'sub oEFT_MAGIC {0x90909090;}';
    eval 'sub di_oeftflag { &di_ic. &ic_oeftflag;}';
    eval 'sub di_ic { &di_un. &di_icom;}';
    eval 'sub di_mode { &di_ic. &ic_smode;}';
    eval 'sub di_nlink { &di_ic. &ic_nlink;}';
    eval 'sub di_uid { &di_ic. &ic_uid;}';
    eval 'sub di_gid { &di_ic. &ic_gid;}';
    eval 'sub di_smode { &di_ic. &ic_smode;}';
    eval 'sub di_suid { &di_ic. &ic_suid;}';
    eval 'sub di_sgid { &di_ic. &ic_sgid;}';
    if (defined &_LITTLE_ENDIAN) {
	eval 'sub di_size { &di_ic. &ic_size. &val[0];}';
    }
    else {
	eval 'sub di_size { &di_ic. &ic_size. &val[1];}';
    }
    eval 'sub di_db { &di_ic. &ic_db;}';
    eval 'sub di_ib { &di_ic. &ic_ib;}';
    eval 'sub di_atime { &di_ic. &ic_atime;}';
    eval 'sub di_mtime { &di_ic. &ic_mtime;}';
    eval 'sub di_ctime { &di_ic. &ic_ctime;}';
    if (defined &_LITTLE_ENDIAN) {
	eval 'sub di_ordev { &di_ic. &ic_db[1];}';
    }
    else {
	eval 'sub di_ordev { &di_ic. &ic_db[0];}';
    }
    eval 'sub di_shadow { &di_ic. &ic_shadow;}';
    eval 'sub di_blocks { &di_ic. &ic_blocks;}';
    eval 'sub di_gen { &di_ic. &ic_gen;}';
    eval 'sub IUPD {0x0001;}';
    eval 'sub IACC {0x0002;}';
    eval 'sub IMOD {0x0004;}';
    eval 'sub ICHG {0x0008;}';
    eval 'sub INOACC {0x0010;}';
    eval 'sub IMODTIME {0x0020;}';
    eval 'sub IREF {0x0040;}';
    eval 'sub ISYNC {0x0080;}';
    eval 'sub IFASTSYMLNK {0x0100;}';
    eval 'sub IMODACC {0x0200;}';
    eval 'sub IATTCHG {0x0400;}';
    eval 'sub IBDWRITE {0x0800;}';
    eval 'sub IBAD {0x1000;}';
    eval 'sub IDEL {0x2000;}';
    eval 'sub IFMT {0170000;}';
    eval 'sub IFIFO {0010000;}';
    eval 'sub IFCHR {0020000;}';
    eval 'sub IFDIR {0040000;}';
    eval 'sub IFBLK {0060000;}';
    eval 'sub IFREG {0100000;}';
    eval 'sub IFLNK {0120000;}';
    eval 'sub IFSHAD {0130000;}';
    eval 'sub IFSOCK {0140000;}';
    eval 'sub ISUID {04000;}';
    eval 'sub ISGID {02000;}';
    eval 'sub ISVTX {01000;}';
    eval 'sub IREAD {0400;}';
    eval 'sub IWRITE {0200;}';
    eval 'sub IEXEC {0100;}';
    eval 'sub I_SYNC {1;}';
    eval 'sub I_DSYNC {2;}';
    eval 'sub I_ASYNC {0;}';
    eval 'sub I_FREE {0x00000001;}';
    eval 'sub I_DIR {0x00000002;}';
    eval 'sub I_IBLK {0x00000004;}';
    eval 'sub I_CHEAP {0x00000008;}';
    eval 'sub I_SHAD {0x00000010;}';
    eval 'sub I_QUOTA {0x00000020;}';
    if (defined &_KERNEL) {
	eval 'sub VTOI {
	    local($VP) = @_;
	    eval "(($VP)-> &v_data)";
	}';
	eval 'sub ITOV {
	    local($IP) = @_;
	    eval "(&($IP)-> &i_vnode)";
	}';
	eval 'sub ITOF {
	    local($IP) = @_;
	    eval "(($IP)-> &i_fs)";
	}';
	if (defined &notneeded) {
	}
	eval 'sub ITIMES_NOLOCK {
	    local($ip) = @_;
	    eval " &ufs_itimes_nolock($ip)";
	}';
	eval 'sub ITIMES {
	    local($ip) = @_;
	    eval "{  &mutex_enter(&($ip)-> &i_tlock);  &ITIMES_NOLOCK($ip);  &mutex_exit(&($ip)-> &i_tlock); }";
	}';
	eval 'sub BMAPALLOC {
	    local($ip, $off, $size, $cr) = @_;
	    eval " &bmap_write(($ip), ($off), ( &daddr_t *) &NULL, 0, ($size), 0, $cr)";
	}';
	eval 'sub ESAME {(-1);}';
	eval 'sub OWNER {
	    local($CR, $IP) = @_;
	    eval "((($CR)-> &cr_uid == ($IP)-> &i_uid)? 0: ( &suser($CR)? 0:  &EPERM))";
	}';
	eval 'sub UFS_HOLE {( &daddr_t)-1;}';
	eval 'sub uq_head { &_uq_head. &_uq_generic;}';
	eval 'sub uq_ihead { &_uq_head. &_uq_i;}';
	eval 'sub uq_ufhead { &_uq_head. &_uq_uf;}';
	eval 'sub UQ_EXIT {(0x0001);}';
	eval 'sub UQ_WAIT {(0x0002);}';
	eval 'sub UQ_SUSPEND {(0x0004);}';
	eval 'sub UQ_SUSPENDED {(0x0008);}';
	eval 'sub UQ_EXISTS {(0x0010);}';
	eval 'sub vfs_fs { &vfs_bufp-> &b_un. &b_fs;}';
	eval 'sub INOHASH {
	    local($dev, $ino) = @_;
	    eval "( &hash2ints($dev, $ino) & ( &inohsz - 1))";
	}';
    }
    if (defined( &_KERNEL)) {
	if (defined( &DEBUG)) {
	    eval 'sub CK_INO {2;}';
	    eval 'sub SET {0;}';
	    eval 'sub CHK {1;}';
	    eval 'sub set_icksum {
	        local($ip) = @_;
	        eval "($ip)-> &i_cksum =  &ufs_icksum($ip)";
	    }';
	    eval 'sub UDBG_OFF {0x000;}';
	    eval 'sub UFS_DEBUG_PANIC {0x001;}';
	    eval 'sub UDBG_ICKSUM {0x002;}';
	    eval 'sub UDBG_IVALID {0x004;}';
	    eval 'sub UDBG_ICKCACHE {0x008;}';
	    eval 'sub UFS_DEBUG_CGCHECK {0x010;}';
	    eval 'sub UFS_DEBUG_ICACHE_CHECK {
	        eval " &ufs_debug_icache_check()";
	    }';
	    eval 'sub UFS_DEBUG_ICACHE_LINECHECK {
	        local($H) = @_;
	        eval " &ufs_debug_icache_linecheck(($H))";
	    }';
	    eval 'sub UFS_DEBUG_ICACHE_ZALLOC {
	        local($SZ, $F) = @_;
	        eval "( &kmem_zalloc(($SZ), ($F)))";
	    }';
	    eval 'sub UFS_DEBUG_ICACHE_INC {
	        local($H) = @_;
	        eval "( &ih_ne[($H)]++)";
	    }';
	    eval 'sub UFS_DEBUG_ICACHE_DEC {
	        local($H) = @_;
	        eval "(-- &ih_ne[($H)])";
	    }';
	}
	else {
	    eval 'sub UFS_DEBUG_ICACHE_CHECK {
	        eval "";
	    }';
	    eval 'sub UFS_DEBUG_ICACHE_LINECHECK {
	        local($H) = @_;
	        eval "";
	    }';
	    eval 'sub UFS_DEBUG_ICACHE_ZALLOC {
	        local($SZ, $F) = @_;
	        eval "0";
	    }';
	    eval 'sub UFS_DEBUG_ICACHE_INC {
	        local($H) = @_;
	        eval "";
	    }';
	    eval 'sub UFS_DEBUG_ICACHE_DEC {
	        local($H) = @_;
	        eval "";
	    }';
	}
    }
    if (defined &__cplusplus) {
    }
}
1;
